<template>
  <v-layout row wrap>
    <v-flex xs12>
      <h4>Médias images</h4>
      <table class="v-datatable v-table theme--light tableauImages">
        <tbody>
          <tr v-for="(image, index) in tableImages" :key="image.id">
            <td>{{ listeLibelleImages[index] }}</td>
            <td class="text-xs-left">
              <form>
                <input :id="'media' + index" :name="'media' + index" type="file" style="display: none" ref="fileInput" @change="setImage" />
                <v-btn color="info" small @click="selectionImage(index)" v-if="previewTn[index] == '' || previewTn[index] == null">Choisir une image</v-btn>
                <v-btn v-if="previewTn[index] != '' && previewTn[index] != null" color="error" small @click="deleteImage(index)"> <i class="material-icons">delete_forever</i> SUPPRIMER </v-btn>
              </form>
            </td>
            <td class="text-xs-right"></td>
            <td>
              <img :src="previewTn[index]" v-if="previewTn[index]" class="previewTn" />
            </td>
          </tr>
        </tbody>
      </table>
      <br />
    </v-flex>
    <v-flex xs12>
      <v-layout>
        <v-flex xs12>
          <progress max="100" :value.prop="uploadPercentage" v-if="uploadPercentage > 0 && uploadPercentage < 100"></progress>

          <v-card v-if="selectedFile">
            <div class="zoneimagesource">
              <vue-cropper
                v-if="selectedFile"
                ref="cropper"
                :guides="true"
                :min-container-width="500"
                :min-container-height="500"
                :view-mode="viewMmode"
                drag-mode="crop"
                :auto-crop-area="autoCropArea"
                :initialAspectRatio="1"
                :background="true"
                :rotatable="true"
                :movable="true"
                :autoCrop="true"
                :cropBoxMovable="true"
                :cropBoxResizable="cropBoxResizable"
                :src="imgSrc"
                :responsive="true"
                :modal="true"
                :img-style="{ width: 1920, height: 1920 }"
                alt="Source Image"
              ></vue-cropper>
              <!-- :min-container-width="parseInt(optionsTn[0].maxWidthTn)" -->
              <!-- :min-container-height="parseInt(optionsTn[0].maxHeightTn)"-->
              <!-- :img-style="{ width: imgStyleWidth, height: imgStyleHeight }" -->
            </div>
            <div>
              <v-btn color="warning" small fab @click="rotate" v-if="imgSrc != ''">
                <i class="material-icons">crop_rotate</i>
              </v-btn>
              <v-btn color="warning" small fab @click="zoomOut()" v-if="imgSrc != ''">
                <i class="material-icons">zoom_out</i>
              </v-btn>
              <v-btn color="warning" small fab @click="zoomIn()" v-if="imgSrc != ''">
                <i class="material-icons">zoom_in</i>
              </v-btn>
              <v-btn color="warning" small fab @click="squareMod()" v-if="imgSrc != ''">
                <i class="material-icons">crop_square</i>
              </v-btn>
              <v-btn color="warning" small fab @click="freeMod()" v-if="imgSrc != ''">
                <i class="material-icons">crop_free</i>
              </v-btn>
              <v-btn color="warning" small fab @click="resetMod()" v-if="imgSrc != ''">
                <i class="material-icons">cached</i>
              </v-btn>
            </div>

            <br />
            <v-btn color="warning" @click="cropImage" v-if="imgSrc != ''"> <i class="material-icons">cloud_upload</i>&nbsp; Upload </v-btn>
          </v-card>
          <!-- <v-img :src="previewImg" v-if="previewImg" aspect-ratio="1" position="center top" contain></v-img> -->
        </v-flex>
      </v-layout>
    </v-flex>

    <loading :active.sync="isLoading" :can-cancel="true" :on-cancel="onCancel" :is-full-page="fullPage"></loading>
  </v-layout>

  <!-- Modification upload  -->
</template>
<script>
// import 'babel-polyfill';
import Vue from "vue";
import VueCropper from "vue-cropperjs";
// import axios from "axios";
import Loading from "vue-loading-overlay";
import "vue-loading-overlay/dist/vue-loading.css";

// const URL_PROXY = "https://cors-anywhere.herokuapp.com/";
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const FOLDER_URL = process.env.VUE_APP_URL_UPLOAD_FOLDER + process.env.VUE_APP_SITE_ALIAS + "/";
const URL_API_POSTIMAGES = URL_API + "api/v1/images";
const URL_API_DELETEIMAGES_FTP = URL_API + "api/images/delete-on-ftp";
// const URL_API_POSTIMAGES_V2 = URL_API + "api/upload/";
const URL_UPLOAD_CONFIG = URL_API + "api/upload-file";
// const URL_API_POSTIMAGES_V2 = URL_PROXY + URL_API + "api/upload/";

export default {
  props: ["Popup", "action", "listeLibelleImages", "tableImages", "tabPrevImgTn", "tabImgName", "recupRawData", "optionsTn"],
  components: {
    "vue-cropper": VueCropper,
    loading: Loading
  },
  mounted: function() {
    this.previewTn = this.tabPrevImgTn;
    this.arrayImgName = this.tabImgName;
    this.setInfoImageUpdate();

    if (this.action == "edit") {
      this.fetchImages();
    }
    this.loadTnConfig();
  },

  data() {
    return {
      // options tn
      cropBoxResizable: true,
      autoCropArea: 1,
      viewMmode: 1,
      isSquare: false,
      imgStyleWidth: "400px",
      imgStyleHeight: "400px",
      // new variables tn (en test)
      cropBoxResizableTab: [],
      autoCropAreaTab: [],
      viewMmodeTab: [],
      isSquareTab: [],

      // loading fullpage
      isLoading: false,
      fullPage: true,

      selectedFile: null,
      selectedCropFile: null,
      previewImg: null,
      previewTn: [],
      uploadPercentage: 0,
      // uploadPercentageTn: 0,
      uploadPercentageTn: [],
      imgSrc: "",
      thumbNailSrc: "",
      cropImg: "",
      cropTn: "",
      imageName: "",
      // idImg: null,
      selectedIndex: null,
      arrayImgName: [],

      // nouveau systeme d'upload
      attachments: [],
      form: new FormData()
    };
  },
  methods: {
    loadTnConfig() {
      this.getIsSquare();
      if (this.selectedIndex !== null) {
        if (this.optionsTn[0].redim == "fixe") {
          this.cropBoxResizable = false;

          if (this.isSquareTab[0]) {
            this.viewMmode = 3;
          } else {
            // this.autoCropArea = 1;
            this.viewMmode = 3;
            this.imgStyleWidth = this.optionsTn[0].maxWidthTn + "px";
            this.imgStyleHeight = this.optionsTn[0].maxHeightTn + "px";
            // this.viewMmode = 0;
          }
        }
        if (this.optionsTn[0].redim == "couleur") {
          this.cropBoxResizable = false;
          this.autoCropArea = 2;
          this.imgStyleWidth = this.optionsTn[0].maxWidthTn + "px";
          this.imgStyleHeight = this.optionsTn[0].maxHeightTn + "px";
          this.viewMmode = 0;
        }
      }
    },
    getIsSquare() {
      // a changer ensuite quand on bouclera sur toutes les tn
      this.optionsTn.forEach((tn, idx) => {
        if (tn.maxHeightTn == tn.maxWidthTn) {
          this.isSquare = true;
          this.isSquareTab[idx] = true;
        } else {
          this.isSquareTab[idx] = false;
        }
      });
      // if (this.selectedIndex) {
      //   console.log("maxHeightTn", this.optionsTn[this.selectedIndex].maxHeightTn);
      //   if (this.optionsTn[this.selectedIndex].maxHeightTn == this.optionsTn[this.selectedIndex].maxWidthTn) {
      //     this.isSquare = true;
      //     this.isSquareTab[this.selectedIndex] = true;
      //   }
      // }
    },
    onCancel() {
      console.log("User cancelled the loader.");
    },
    fetchImages() {
      let dataEdit = JSON.parse(this.recupRawData.data);
      // boucle sur tableimage
      if (this.tableImages) {
        this.tableImages.forEach((element, index) => {
          if (dataEdit["image" + (index + 1)] != undefined && dataEdit["image" + (index + 1)] != "" && dataEdit["image" + (index + 1)].length > 0) {
            let imgName = dataEdit["image" + (index + 1)];
            if (imgName != "" && imgName.length > 0) {
              let url = FOLDER_URL + "tn/tn1-" + imgName;
              this.setPreviewTn(index, url);
              Vue.set(this.arrayImgName, index, imgName);
            }
          }
        });
      }

      // affecter a preview img tn
    },
    selectionImage(index) {
      this.selectedIndex = index;
      this.loadTnConfig();
      this.$refs.fileInput[index].click();
    },
    setImage(e) {
      this.selectedFile = e.target.files[0];
      this.imageName = this.setImageName(this.selectedFile.name);
      this.uploadPercentage = 0;
      if (!this.selectedFile.type.includes("image/")) {
        alert("Please select an image file");
        return;
      }
      if (typeof FileReader === "function") {
        const reader = new FileReader();
        reader.onload = event => {
          this.imgSrc = event.target.result;
          // rebuild cropperjs with the updated source
          this.$refs.cropper.replace(event.target.result);
        };
        reader.readAsDataURL(this.selectedFile);
      } else {
        alert("Sorry, FileReader API not supported");
      }
    },
    cropImage(e) {
      e.preventDefault();
      this.isLoading = true;
      var self = this;

      // -------------- UPLOAD SERVEUR FTP ---------------- //

      // this.cropImg = this.$refs.cropper.getCroppedCanvas();
      // options a parametrer et récup du builder
      let cropImgTab = [];
      this.optionsTn.forEach((tn, idx) => {
        cropImgTab[idx] = this.$refs.cropper.getCroppedCanvas({
          fillColor: tn.bgTn,
          width: tn.maxWidthTn,
          height: tn.maxHeightTn,
          // minWidth: tn.maxWidthTn,
          // minHeight: tn.maxHeightTn
          maxWidth: tn.maxWidthTn,
          maxHeight: tn.maxHeightTn
        });
      });

      this.cropImg = this.$refs.cropper.getCroppedCanvas({
        fillColor: this.optionsTn[0].bgTn,
        width: this.optionsTn[0].maxWidthTn,
        height: this.optionsTn[0].maxHeightTn,
        maxWidth: this.optionsTn[0].maxWidthTn,
        maxHeight: this.optionsTn[0].maxHeightTn

        // minWidth: this.optionsTn[0].maxWidthTn,
        // minHeight: this.optionsTn[0].maxHeightTn,

        // ------------------------- INITIAL
        // fillColor: this.optionsTn.bgTn,
        // width: this.optionsTn.tabTn[0].maxWidthTn,
        // height: this.optionsTn.tabTn[0].maxHeightTn,
        // minWidth: this.optionsTn.tabTn[0].maxWidthTn,
        // minHeight: this.optionsTn.tabTn[0].maxHeightTn
        // ------------------------
        // maxWidth: this.optionsTn.tabTn[0].maxWidthTn,
        // maxHeight: this.optionsTn.tabTn[0].maxHeightTn
      });
      console.log("this.cropImg", this.cropImg);
      let imgTab = [];
      cropImgTab.forEach((elCrop, index) => {
        imgTab[index] = elCrop.toDataURL("image/jpeg", 1.0);
      });
      let img = this.cropImg.toDataURL("image/jpeg", 1.0);
      let data = new FormData();
      data.append("media", img);
      data.append("allMedia", JSON.stringify(imgTab));
      data.append("indexFile", self.selectedIndex);
      data.append("imageName", this.selectedFile.name);
      data.append("aliasFolder", process.env.VUE_APP_SITE_ALIAS);

      // variable provenant du builder
      let tnTab = JSON.stringify(this.optionsTn);
      data.append("tnTab", tnTab);

      const config = {
        headers: { "Content-Type": "multipart/form-data" }
      };
      // self.isLoading = false;
      // return false;
      console.log("data", data);
      this.$axios
        // .post(URL_API_POSTIMAGES_V2, data, config)
        .post(URL_UPLOAD_CONFIG, data, config)
        .then(response => {
          //success
          let imgName = response.data.imgName;
          // let url = FOLDER_URL + "tn/" + imgName;
          let url = FOLDER_URL + "tn/tn1-" + imgName;
          self.setPreviewTn(self.selectedIndex, url);
          Vue.set(self.arrayImgName, self.selectedIndex, imgName);
          console.log("arrayImgName", self.arrayImgName);
          //passage info au parent
          self.$emit("childToParent", self.arrayImgName);
          self.isLoading = false;
        })
        .catch(response => {
          self.isLoading = false;
          console.log("error", response);
          //error
        });
    },
    setPreviewTn(idx, url) {
      Vue.set(this.previewTn, idx, url);
    },
    deleteImage(idx) {
      this.arrayImgName[idx] = null; // todo a passer en []
      this.setPreviewTn(idx, null);
      this.$emit("childToParent", this.arrayImgName);
      // suppression ftp désactivé temporairement
      // sera déplacé dans le futur dans une fonction nettoyage
      // this.isLoading = true;
      // let urlDelete = "";
      // let payload = {
      //   name: this.arrayImgName[idx]
      // };
      // axios
      //   .post(URL_API_DELETEIMAGES_FTP, payload)
      //   .then(response => {
      //     this.arrayImgName[idx] = null; // todo a passer en []
      //     this.setPreviewTn(idx, null);
      //     //passage info au parent
      //     this.$emit("childToParent", this.arrayImgName);
      //     this.isLoading = false;
      //   })
      //   .catch(error => {
      //     console.log("error = ", error);
      //     this.isLoading = false;
      //   });
    },
    rotate(e) {
      e.preventDefault();
      var self = this;
      this.$refs.cropper.rotate(90);
    },
    zoomIn() {
      this.$refs.cropper.relativeZoom(-0.1);
    },
    zoomOut() {
      this.$refs.cropper.relativeZoom(0.1);
    },
    squareMod() {
      this.$refs.cropper.setAspectRatio(1);
    },
    freeMod() {
      this.$refs.cropper.setAspectRatio(0);
    },
    resetMod() {
      this.$refs.cropper.reset();
    },
    setImageName(rawName) {
      let newName = rawName;
      let tab1 = "ÀÁÂÃÄÅàáâãäåÒÓÔÕÖØòóôõöøÈÉÊËèéêëÇçÌÍÎÏìíîïÙÚÛÜùúûüÿÑñ";
      let tab2 = "aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn";
      let rep2 = tab1.split("");
      let rep = tab2.split("");
      let myarray = new Array();
      let i = -1;
      while (rep2[++i]) {
        myarray[rep2[i]] = rep[i];
      }
      myarray["Œ"] = "OE";
      myarray["œ"] = "oe";

      newName = newName.replace(/./g, function($0) {
        return myarray[$0] ? myarray[$0] : $0;
      });
      newName = newName.replace(/[^.a-zA-Z0-9_-]/g, "");
      var random = Math.floor(Math.random() * 10000 + 1000);
      var unix = Math.round(+new Date() / 1000);
      return unix + random + newName;
    },

    setInfoImageUpdate() {
      this.tableImages.forEach((element, index) => {
        //ATTENTION CETTE COMMANDE AGRANDIT INUTILEMENT LE TABLEAU EN MODE CREATE
        // Vue.set(this.previewTn, index, []);
        if (this.previewTn.length < this.tableImages.length) {
          this.previewTn.push([]);
          this.arrayImgName.push([]);
        }
      });

      if (this.editMode) {
        //this.idImg = this.Popup.data.image1ID;
        //this.previewImg = this.Popup.data.image1Url;
      }
    }
  }
};
</script>
<style scoped>
.zoneimagesource {
  max-width: 100%;
  /* width: 400px; */
  /* height:300px;  */
  /* border: 1px solid gray;  */
  display: inline-block;
}
.cropImg {
  max-width: 100%;
  /* max-width: 400px;
  max-height: 400px; */
  /* width: 200px; */
  /* height: 150px; */
  border: 1px solid gray;
}
</style>
